//
// $Id: Memory_Growth.cpp 76591 2007-01-25 18:17:52Z elliott_c $
//
#include "Memory_Growth.h"
#include "ace/Manual_Event.h"

ACE_RCSID (IORSize,
           Memory_Growth,
           "$Id: Memory_Growth.cpp 76591 2007-01-25 18:17:52Z elliott_c $")

Memory_Growth::Memory_Growth (CORBA::ORB_ptr orb)
  : orb_ (CORBA::ORB::_duplicate (orb))
{
}

void
Memory_Growth::send_objref (const Test::PayLoad & /*p*/
                            )
  ACE_THROW_SPEC ((CORBA::SystemException))
{
  ACE_Manual_Event me;

  ACE_DEBUG ((LM_DEBUG,
              "(%P|%t) Going to wait .. \n"));

  me.wait ();

  ACE_DEBUG ((LM_DEBUG,
              "(%P|%t) Wokeup from wait .. \n"));
  return;
}

void
Memory_Growth::shutdown (void)
  ACE_THROW_SPEC ((CORBA::SystemException))
{
  this->orb_->shutdown (0);
}
