// $Id: test_i.cpp 76555 2007-01-24 15:39:09Z johnnyw $

#include "test_i.h"

ACE_RCSID(MT_Client, test_i, "$Id: test_i.cpp 76555 2007-01-24 15:39:09Z johnnyw $")

Simple_Server_i::Simple_Server_i (CORBA::ORB_ptr orb)
  : orb_ (CORBA::ORB::_duplicate (orb)),
    val_ (1)
{
}

Simple_Server_i::Simple_Server_i (void)
  : orb_ (0)
{
  // no-op
}

CORBA::Long
Simple_Server_i::remote_call (void)
  ACE_THROW_SPEC ((CORBA::SystemException))
{
  ACE_DEBUG ((LM_DEBUG,
              "Print out from process id (%P) hosting the servant \n"));

  return this->val_++;
}


void
Simple_Server_i::shutdown (void)
  ACE_THROW_SPEC ((CORBA::SystemException))
{
  this->orb_->shutdown (0);
}
